


diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/bab/bab.h baghira-ng/bab/bab.h
--- baghira-0.6b/bab/bab.h	2005-02-07 18:05:51.000000000 +0100
+++ baghira-ng/bab/bab.h	2005-02-08 21:18:53.000000000 +0100
@@ -108,9 +108,9 @@ private slots:
 class Corner : public QWidget
 {
     Q_OBJECT
-public:
-    enum Side {left = 0, right};
-    Corner(Side side);
+    public:
+        enum Side {left = 0, right};
+        Corner(Side side);
 };
-   
+
 #endif // _BAB_H_


diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/bab/main.cpp baghira-ng/bab/main.cpp
--- baghira-0.6b/bab/main.cpp	2005-02-07 18:05:51.000000000 +0100
+++ baghira-ng/bab/main.cpp	2005-02-11 17:02:10.000000000 +0100
@@ -435,7 +435,6 @@ void BabSwitcher::paintEvent(QPaintEvent
 
 Corner::Corner(Side side) : QWidget(0, (side == left)?"left_corner":"right_corner", Qt::WType_TopLevel | Qt::WStyle_NoBorder | Qt::WStyle_StaysOnTop | Qt::WX11BypassWM )
 {
-    
     if (side == left) {
         setFixedSize(5,4);
         move(0,0);
@@ -457,9 +456,9 @@ Corner::Corner(Side side) : QWidget(0, (
         xrects[ 3 ].x = 0;
         xrects[ 3 ].y = 3;
         xrects[ 3 ].width = 1;
-        xrects[ 3 ].height = 2;                
+        xrects[ 3 ].height = 2;
         XShapeCombineRectangles( qt_xdisplay(), winId(), ShapeBounding, 0, 0,
-            xrects, 4, ShapeSet, 0 );
+                                 xrects, 4, ShapeSet, 0 );
         delete[] xrects;
     }
     else {
@@ -483,9 +482,9 @@ Corner::Corner(Side side) : QWidget(0, (
         xrects[ 3 ].x = 4;
         xrects[ 3 ].y = 3;
         xrects[ 3 ].width = 1;
-        xrects[ 3 ].height = 2;          
+        xrects[ 3 ].height = 2;
         XShapeCombineRectangles( qt_xdisplay(), winId(), ShapeBounding, 0, 0,
-            xrects, 4, ShapeSet, 0 );
+                                 xrects, 4, ShapeSet, 0 );
         delete[] xrects;
     }
 }










diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/deco/baghiraclient.cc baghira-ng/deco/baghiraclient.cc
--- baghira-0.6b/deco/baghiraclient.cc	2005-02-07 18:05:51.000000000 +0100
+++ baghira-ng/deco/baghiraclient.cc	2005-02-08 21:19:46.000000000 +0100
@@ -1573,8 +1573,10 @@ bool BaghiraClient::eventFilter( QObject
 	case QEvent::MouseButtonPress: {
             if (titlebar_->geometry().contains( static_cast<QMouseEvent *>(e)->pos() ) && static_cast<QMouseEvent *>(e)->state() == Qt::ControlButton){
                 currentStyle < 2 ? currentStyle++ : currentStyle = 0;
+#if KDE_IS_VERSION(3,3,91)
                 unsigned long wmDesign = currentStyle;
                 XChangeProperty(qt_xdisplay(), windowId(), baghira_deco_design, XA_CARDINAL, 32, PropModeReplace, (unsigned char *) &wmDesign, 1L);
+#endif
                 widget()->repaint();
                 QBitmap *m = NULL;
                 QBitmap *mn = NULL;














diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/kickermenu/menuapplet.cpp baghira-ng/kickermenu/menuapplet.cpp
--- baghira-0.6b/kickermenu/menuapplet.cpp	2005-02-07 18:05:51.000000000 +0100
+++ baghira-ng/kickermenu/menuapplet.cpp	2005-02-08 20:17:10.000000000 +0100
@@ -147,12 +147,15 @@ void Applet::windowAdded( WId w_P )
         title = new QString( classHint.res_class );
         XFree( classHint.res_name );
         XFree( classHint.res_class );
+        if (title->contains("SDL_App"))
+            goto titlejump; //sorry - mainly for scummvm apps
         windowTitleDict.insert(w_P, title);
     }
     else
     { //fallback
     // for windowindicator
     if (!windowTitleDict[w_P] && w_P != qt_xrootwin()){
+titlejump:
        KWin::WindowInfo tmpInfo = KWin::windowInfo( w_P, NET::WMName );
         //generate title:
         title = new QString(tmpInfo.name());





diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/style/baghira.cpp baghira-ng/style/baghira.cpp
--- baghira-0.6b/style/baghira.cpp	2005-02-07 18:05:52.000000000 +0100
+++ baghira-ng/style/baghira.cpp	2005-02-08 14:38:15.000000000 +0100
@@ -1168,9 +1168,10 @@ void LiquidStyle::drawPrimitive( Primiti
 // 				break;
 				}
 			case PE_Separator:
-			/*case PE_DockWindowSeparator:*/ {
+			case PE_DockWindowSeparator: {
+                            break; //don't draw anything
                                 //qWarning("%s",p->device()->className());
-                                if (!(p->device() && p->device()->devType() == QInternal::Widget && ::qt_cast<QToolBar*>((QWidget*)p->device()) /*((QWidget*)p->device())->inherits("QToolBar")*/)){
+                                if (!(p->device() && p->device()->devType() == QInternal::Widget && ::qt_cast<QToolBar*>((QWidget*)p->device()))){
 				if ( !( flags & Style_Horizontal ) ) {
 					p->setPen( cg.mid() );
 					p->drawLine( 4, r.height() / 2, r.width() - 5, r.height() / 2 );
@@ -1997,8 +1998,8 @@ void LiquidStyle::drawComplexControl( Co
 				if ( widget == highlightWidget )
 					bflags |= Style_MouseOver;
 				if ( controls & SC_ToolButton ) {
-					bool sunken = mflags & ( Style_Down | Style_On );
-					bool hover = bflags & Style_MouseOver;
+                                    bool sunken = mflags & ( Style_Down /*| Style_On*/ );
+                                        bool hover = bflags & (Style_MouseOver | Style_On );
                                         
                                         if ( !optionHandler->useToolButtonFrame() || !(toolbutton->parentWidget() && ( ::qt_cast<QToolBar*>(toolbutton->parentWidget()) || toolbutton->parentWidget()->inherits("KonqFrameTabs")))) {
                                             if (!(hover || sunken) && toolbutton->parentWidget() && !::qt_cast<QToolBar*>(toolbutton->parent()) && toolbutton->parentWidget()->paletteBackgroundPixmap() && !toolbutton->parentWidget()->paletteBackgroundPixmap()->isNull()) {


diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/style/optionHandler.cpp baghira-ng/style/optionHandler.cpp
--- baghira-0.6b/style/optionHandler.cpp	2005-02-07 18:05:52.000000000 +0100
+++ baghira-ng/style/optionHandler.cpp	2005-02-11 19:58:46.000000000 +0100
@@ -168,7 +168,7 @@ void OptionHandler::reloadSettings() {
 	animateSlider = config.readBoolEntry( "Special_AnimateSlider", true );
 	// toolbar
         int utb = config.readNumEntry( "Special_UnhoveredToolButtons", 2 );
-        tbFrame = utb == 2 || (brushMe && utb == 1) || (!brushMe && utb == 0);
+        tbFrame = (utb == 2) || (brushMe && (utb == 1)) || (!brushMe && (utb == 0));
 
 	// tweaks
 	centerTabs = config.readBoolEntry( "Design_CenterTabs", true);

diff -updr -x '*~' -x '*.in' -x '*.moc' -x '*.la' -x '*.o' -x '*.lo' -x Makefile -x '*.orig' -x '.*' baghira-0.6b/style/polish.cpp baghira-ng/style/polish.cpp
--- baghira-0.6b/style/polish.cpp	2005-02-07 18:05:52.000000000 +0100
+++ baghira-ng/style/polish.cpp	2005-02-10 22:03:26.000000000 +0100
@@ -910,10 +910,12 @@ void LiquidStyle::unPolish( QWidget *w )
                     if (w->inherits( "QPushButton" ))
                     {
                         ButtonFadeInfo *bfi_ = bfi[w->winId()];
+                        if (bfi_){
                         if (bfi_->timerId != 0)
                             w->killTimer(bfi_->timerId);
                         bfi.setAutoDelete(TRUE);
                         bfi.remove(w->winId());
+                        }
                     }
 		  w->setBackgroundMode( QWidget::PaletteButton );
 		} else if ( w->inherits( "QScrollBar" ) ) {